package com.ajinkya.frontend;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.UnknownHostException;
import java.util.Iterator;
import java.util.List;

import javax.swing.AbstractButton;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;

import com.ajinkya.myExcelreader.mongo.ExcelReader;
import com.ajinkya.myExcelreader.mongo.ExcelRecord;
import com.google.code.morphia.Datastore;
import com.google.code.morphia.Morphia;
import com.mongodb.Mongo;
import com.mongodb.MongoException;

public class FrontEnd extends JApplet implements ActionListener,MouseListener {
	private JButton jButton;
	private JButton jButton2;
	
	JFrame frame = new JFrame("JFrame Source Demo");
	
	JTextField jTextField;
	// Add a window listner for close button
	
	
	
	public FrontEnd() throws UnknownHostException, MongoException{
		
		DefaultTableModel dataModel = new DefaultTableModel();
		JTable jTable = new JTable(dataModel);
		
		//jTable.setRowHeight(50);
		
		dataModel.addColumn("Tag");
		dataModel.addColumn("Datum");
		dataModel.addColumn("Anfang");
		dataModel.addColumn("Ende");
		dataModel.addColumn("Raum");
		dataModel.addColumn("Veransbiltingsname");
		dataModel.addColumn("Dozent");
		dataModel.addColumn("Kommentar");
		
		 dataModel.insertRow(0,new Object[]{"Tag","Datum","Anfang","Ende","Raum","Veransbiltungsname"
				 ,"Dozent","Kommentar"});
		// jTable.setFont(new Font("", arg1, arg2))
		String[] columnNames = {"First Name",
                "Last Name",
                "Sport",
                "# of Years",
                "Vegetarian"};
		
		
		Mongo mongo = new Mongo();
		Morphia morphia = new Morphia();
		morphia.map(ExcelRecord.class); // Object relation mapper
		Datastore ds = morphia.createDatastore(mongo, "local");
		
		List<ExcelRecord> ex = ds.find(ExcelRecord.class).asList();
	
		Iterator<ExcelRecord> iteration = ex.iterator();
		//jTable = new JTable(ex.size()+1,7);
		//int i=0;
		for(int i=0;i<ex.size();i++)
		{
			
			//iteration.next();
			dataModel.insertRow(i+1, new Object[] 
			       {ex.get(i).getTag(),
					ex.get(i).getDatum(),
					ex.get(i).getAnfang(),
					ex.get(i).getEnde(),
					ex.get(i).getRaum(),
					ex.get(i).getVeranstaltungsname(),
					ex.get(i).getDozent(),
					ex.get(i).getKommentar()
					
					});
			
			
		}

		
	
		
		
		
		
		
		
		
	jButton = new JButton("Upload File");
	
	jButton.setVerticalTextPosition(AbstractButton.CENTER);
	jButton.setHorizontalTextPosition(AbstractButton.LEADING);
	
	jButton.addMouseListener(this);
	jButton2 = new JButton("Load Data");
	
	JLabel jlbempty = new JLabel("hello");
	jlbempty.setPreferredSize(new Dimension(500, 200));
	jTextField = new JTextField();
	jTextField.setSize(100, 30);
	
	//frame.getContentPane().add(jTextField, BorderLayout.CENTER);
	frame.getContentPane().add(jTable);
	//frame.getContentPane().add(jButton,BorderLayout.NORTH);
	frame.getContentPane().add(jButton2,BorderLayout.SOUTH);
	
	frame.setSize(new Dimension(600,300));
	frame.setVisible(true);
	frame.addWindowListener(new WindowAdapter() {

		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	});
	}
	
	public static void main(String s[]) throws UnknownHostException, MongoException {
		FrontEnd f = new FrontEnd();
		
		// This is an empty content area in the frame

		
	}
	@Override
	public void actionPerformed(ActionEvent arg0) {
		
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {
		// TODO Auto-generated method stub
		System.out.println(arg0.getSource());
		ExcelReader reader = new ExcelReader();
		reader.interateExcel();
		jTextField.setText("File has been saved into the Database");
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	public void loadData(){
		
	}
}
