package com.ajinkya.myExcelreader.mongo;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.swing.plaf.SliderUI;

import com.google.code.morphia.Datastore;
import com.google.code.morphia.Morphia;
import com.mongodb.*;

import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.hssf.usermodel.HSSFDateUtil;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFCell;

public class ExcelReader {

	ExcelRecord excelRecord = new ExcelRecord();
	public void readExcel(ExcelRecord excelRecord) throws UnknownHostException, MongoException{
		
		Mongo mongo = new Mongo();
		Morphia morphia = new Morphia();
		morphia.map(ExcelRecord.class); // Object relation mapper
		Datastore ds = morphia.createDatastore(mongo, "local");
		
		
		MongoConnection connection = new MongoConnection();
		Mongo connect = (Mongo)connection.getConnection(); // Get MongoDB connection
		DB db = connect.getDB("local");
		DBCollection coll = db.getCollection("mycoll");
		
		BasicDBObject doc = new BasicDBObject();
		doc.put("name ", "Ajinky");
		doc.put("Surname", "Prabhune");
		if(!excelRecord.getTag().equals("Tag"))
		ds.save(excelRecord);           // Save data in the MongoDB
		
		//coll.insert(doc);
		System.out.println("Written-----------------------");
		
		
	}
	
	
	@SuppressWarnings("deprecation")
	public void interateExcel(){
	FileInputStream fis = null;
	boolean isDate;
	int count=0;
	try {
		File file = new File("G:\\ProgramIDE\\tempfile.xls");
		fis = new FileInputStream(file);
		//fis = new FileInputStream("G:\\ProgramIDE\\tempfile.xls");
		System.out.println(file.getName());
		HSSFWorkbook workbook = new HSSFWorkbook(fis);
		HSSFSheet sheet = workbook.getSheetAt(0);
		
		//			
					
		            Iterator rows = sheet.rowIterator();
		            
		            while (rows.hasNext()) {
		            	
		            	HSSFRow row = (HSSFRow) rows.next();
		                
		                Iterator cells = row.cellIterator();
		 
		                List data = new ArrayList();
		                while (cells.hasNext()) {
		                    HSSFCell cell = (HSSFCell) cells.next();
		                   
		                    
		                    try {
		                    	boolean tr = HSSFDateUtil.isCellDateFormatted(cell);
		                    	data.add(cell.getDateCellValue());
		                    	System.out.println(cell.getDateCellValue());
		                    	
		                    	System.out.print(tr);
		                        }
		                    catch (Exception e) {
								// TODO: handle exception
							}
		                   // System.out.println(cell);
		                    BasicDBObject doc = new BasicDBObject();
		                   // doc.put("Tag", "")
		                    System.out.println(cell);
		                    if(!cell.toString().contains("IF("))
		                    data.add(cell);
		                    
		                }
		                
		                // Creating the Object to be Persisted
		                if(!data.get(0).toString().contains("Tag")){
		                excelRecord.setId(count);
		                //String temp = (String) data.get(0).toString();
		                excelRecord.setTag((String)data.get(0).toString());
		                excelRecord.setDatum(data.get(1).toString());
		                excelRecord.setAnfang((String)data.get(2).toString().substring(10,16));
		                excelRecord.setEnde((String)data.get(4).toString().substring(10,16));
		                excelRecord.setRaum((String)data.get(6).toString());
		                excelRecord.setVeranstaltungsname((String)data.get(7).toString());
		                excelRecord.setDozent((String)data.get(8).toString());
		                
		                if(data.get(9)!= null){
		                excelRecord.setKommentar((String)data.get(9).toString());
		                }
		                else
		                excelRecord.setKommentar("No Commentator");
		                readExcel(excelRecord);
		                
		                }
		                Thread.sleep(10);
		                count ++;
		                
		            }
		          }
	 catch (FileNotFoundException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (InterruptedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	
		
	}
	public void displayData() throws UnknownHostException, MongoException{
		Mongo mongo = new Mongo();
		Morphia morphia = new Morphia();
		morphia.map(ExcelRecord.class); // Object relation mapper
		Datastore ds = morphia.createDatastore(mongo, "local");
		
		
		MongoConnection connection = new MongoConnection();
		List<ExcelRecord> ex = ds.find(ExcelRecord.class).asList();
		//System.out.println(ex.get(0).getId() +" " +"-----------");
	}
	
	public static void main(String[] args) throws UnknownHostException, MongoException {
		ExcelReader reader = new ExcelReader();
		//reader.readExcel();
		reader.interateExcel();
		reader.displayData();
		
	}
}
